/*------------------------------------------------*/
/* c18/dynamic1.c                                 */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>

#ifdef _MSC_VER
	#define ZU  "Iu"
	#define SZU "lu"
#else
	#define ZU  "zu"
	#define SZU "zu"
#endif

/**
* funkce pro setrideni pole od nejmensiho do nejvetsiho
*/
void setrid(size_t delka, float pole[])
{
    size_t i, j;
    float pom;

    for (j = 0; j < delka - 1; j++) {
	i = 0;
	do {
	    if (pole[i] > pole[i + 1]) {
		pom = pole[i];
		pole[i] = pole[i + 1];
		pole[i + 1] = pom;
	    }
	    i++;
	} while (i < delka - 1);
    }
}

int main(void)
{
    size_t i;
   /*
   ukazatel na dynamicky alokovane cislo, ktere bude urcovat
   delku pole pro tridene cisla. V tomto pripade by bylo
   lepsi pouzit statickou promennou (size_t i);
   je to tu tak udelano jen pro nazorny priklad */
    size_t *ui;
   /* ukazatel na dynamicky alokovane pole, do ktereho budou
      ulozeny tridene cisla */
    float *uf;


    ui = (size_t *) malloc(sizeof(size_t));
    if (ui == NULL) { /* jeden mozny zpusob kontroly */
	printf("Nedostatek pameti!\n");
	return 0;
    }

    printf("Zadejte pocet cisel: ");
    /* u funkce scanf by se melo kontrolovat, zda skutecne
       nacetla to, co mela. Pro strucnost prikladu to nedelam */
    scanf("%" SZU, ui);

    /* pozadam o tolik bytu, kolik ma typ float krat pocet prvku pole */
    if ((uf = (float *) malloc(sizeof(float) * (*ui))) == NULL)
	/* taky zpusob kontroly :-) */
    {
	printf("Nedostatek pameti!\n");
	return 0;
    }

    for (i = 0; i < *ui; i++) {
	printf("Zadejte cislo [%2" ZU "]: ", i + 1);
	scanf("%f", uf + i); /* nebo uf[i] */
    }

    setrid(*ui, uf);

    for (i = 0; i < *ui; i++) {
	printf("%5.2f ", uf[i]); /* nebo uf + i */
    }
    printf("\n");
    free(ui);
    free(uf);
    return 0;
}

/*------------------------------------------------*/
