/*------------------------------------------------*/
/* konverze/tobin.c                               */
#define _CRT_SECURE_NO_WARNINGS
#include <string.h>
#include <wchar.h>
/**
* Převede char na něco jako "11010011"
*/
char * chtobin(unsigned char c) {
        static char binary[9];
        int i;
        binary[8] = '\0';
        for (i = 7; i >= 0; i--) {
                binary[i] = (c & 1) ? '1' : '0';
                c >>= 1;
        }
        return binary;
}

/**
* Přewede wide char na něco jako 11010011 11010011 ...
*/
char *wstobin(wchar_t w) {
    static char bin[9*sizeof(wchar_t)+1];
    char *ub = bin;
    unsigned char *ch = (unsigned char *)&w;
    int i;
    for (i =0; i < sizeof(w); i++) {
        strcpy(ub, chtobin(*(ch + i)));
        ub += 8;
        *ub = ' ';
        ub++;
    }
    bin[sizeof(w)*9+1] = '\n';
    return bin;
}

/*------------------------------------------------*/
